package ie.ucd.csi.comp10050.cellular_automata;

/**
 * The fundamental unit of a cellular automata.
 *
 * @author Joe Kiniry (kiniry@ucd.ie)
 * @module COMP 10050
 * @organisation School of Computer Science and Informatics
 * @copyright University College Dublin
 * @version 5 April 2006
 */

public abstract class BasicCell extends Cell {
  // @design kiniry 10 March 2006 - Basic cells have only two values,
  // that are interpreted as either "white" or "black", "on" or "off",
  // "1" or "0", etc.

  // @bon query

  /** {@inheritDoc} */
  //@ also
  //@ ensures (the_value == 0 | the_value == 1) <==> \result;
  public abstract boolean validValue(final long the_value);

  /** {@inheritDoc} */
  //@ also
  //@ ensures \result == 2;
  public abstract long validValueCount();

  /** {@inheritDoc} */
  //@ also
  //@ ensures \result == ' ' <==> value() == 0;
  //@ ensures \result == '*' <==> value() == 1;
  public abstract char textualRepresentation();

  /** {@inheritDoc} */
  //@ also
  //@ requires a_cell instanceof BasicCell;
  public abstract /*@ pure @*/ boolean equals(final /*@ nullable */ Object a_cell);

  // @bon command

  // @bon constraint
}
