/**
 * Person born or living in a country.
 *
 * @created 1993-03-15 jmn
 * @revised 1993-05-12 kw
 */
package civil_status.bon;

class Citizen {
  // queries

  /**
   * @return What is your name?
   */
  /** @bon Name? */
  /*@ pure @*/ String name();

  /** @bon Sex? */
  /** @bon Age? */
  /** @bon Single? */
  /** @bon Spouse? */
  /** @bon Children? */
  /** @bon Parents? */
  /** @bon Impediment to marriage? */

  // commands

  /** @bon Marry! */
  void marry(Citizen spouse);
  /** @bon Divorce. */

  // constraints

  /** @bon Each citizen has two parents. */
  /** @bon At most one spouse allowed. */
  /** @bon May not marry children or parents or person of same sex. */
  /** @bon Spouse's spouse must be this person. */
  /** @bon All children, if any, must have this person among their parents. */
}
