/**
 * Person of noble rank.
 *
 * @created 1993-03-15 jmn
 * @revised 1993-05-12 kw, 1993-12-10 kw
 */
package civil_status;

class Nobleperson extends Citizen {

  /** @bon Enough property for independence. */
  //@ public invariant butler != null;
  //@ public invariant 7 <= assets;


  /**
   * @bon Assets?
   * The bare necessities of life.
   */
  protected /*@ spec_public @*/ double assets;

  /**
   * @bon Butler?
   * Irons the morning paper.
   */
  protected /*@ spec_public @*/ Citizen butler;

  /* Lord or Lady */
  //@ public invariant spouse != null ==> \typeof(spouse) <: \type(Nobleperson);

  protected Nobleperson() {
    super();
    assets = 0;
    // butler = new Citizen();
  } //@ nowarn Invariant;

  /**
   * Celebrate with style.
   * @param fiancee future noble husband or wife
   * @bon Can only marry other noble person.
   * @design ^^^
   * @bon Wedding celebrated with style.
   * @design ...
   * @bon Married nobility share their assets and must have a butler.
   * @design ...
   */
  /*@ also
    @ requires fiancee != null;
    @ requires \typeof(fiancee) <: \type(Nobleperson);
    @ requires 50007 <= assets + ((Nobleperson)fiancee).assets ;
    @ requires sex == MALE;
    @ ensures butler != null;
    @ ensures assets == \old(assets + ((Nobleperson)fiancee).assets - 50000);
    @ ensures ((Nobleperson)fiancee).assets == 7;
    @*/
  public void marry(Citizen fiancee) {
    spouse = fiancee;
    assets = assets + ((Nobleperson)fiancee).assets - 50000 + 7;
    ((Nobleperson)fiancee).assets = 7;
  }
}